import os
import json

from p2.store.client import Client
from p2.logging import HttpLogger

class ConfigLib:

    def __init__(self):

        p2_store_url = os.getenv('P2_STORE_URL')
        if p2_store_url is None:
            raise Exception("No P2_STORE_URL envar found")
        self.client = Client(p2_store_url)

    def update_config(self, new_rec: dict):
        ret = self.client.update_on_conflict(
            table='config',
            record=new_rec,
            conflicting_cols=['component', 'tag']
        )
        if ret is None:
            raise Exception(f"Error updating configuration for componenent {component}")
        else:
            rec = self.client.select(
                table='config',
                filter={ 'component': new_rec['component'] }
            )
        if rec is None or len(rec) == 0:
            raise Exception(f"Error updating configuration for componenent {component}")
        else:
            return rec[0]
