var display_components_list_url='/config/api/display_components_list'
var selected_item;

function display_components_list() {
    display_config_layout();

    var config_source = {
        datatype: "json",
        datafields: [ { name: 'component' }, { name: 'tag' } ],
        url: display_components_list_url
    };
    var config_dataAdapter = new $.jqx.dataAdapter(config_source);

    $("#compList").jqxGrid({
        width: '100%',
        height: '98%',
        // autoheight: true,
        sortable: true,
        pageable: true,
        selectionmode: 'singlerow',
        // pagesizeoptions: ['10', '20', '30'],
        pagesize: 15,
        source: config_dataAdapter,
        columns: [
            { text: 'Component', datafield: 'component', width: "50%" },
            { text: 'Tag', datafield: 'tag', width: "50%"}
        ]
    });

    var editor_container = document.getElementById("compConfigEditor");
    // 'text' or 'tree'
    var options = {
        mode: 'text'
    };
    var editor = new JSONEditor(editor_container, options);
    create_save_button(editor);

    $('#compList').on('rowselect', function (event) {
        var args = event.args;
        if (args) {
            var item = args.row;
            selected_item = item;

            $.ajax({
                url: '/config/api/get_component_config/'+selected_item.component+'/'+selected_item.tag,
                success: function(result) {
                    editor.set(result)
                },
                error: function(request,msg,error) {
                    display_ack_window("", "Error getting configuration parameters for component "+selected_item.component);
                }
            });
        } else {
            display_ack_window("", "Error getting component configuration parameters");
        };
    });
}

function display_config_layout() {
    $("#appWorkspace").append(`
        <div id="compConfigMenu" bp=12>
            <input type="button" id="saveConfig"/>
        </div>
        <div id="compLayout" bp=12>
            <div data-container="compListContainer">
                <div id="compList"></div>
            </div>
            <div data-container="compConfigContainer">
                <div id="compConfigEditor"></div>
            </div>
        </div>
    `);

    var layout = [{
        type: 'layoutGroup',
        orientation: 'horizontal',
        width: '100%',
        items: [{
            type: 'documentGroup',
            width: '20%',
            items: [{
                type: 'documentPanel',
                title: 'Components List',
                contentContainer: 'compListContainer'
            }]
        },{
            type: 'documentGroup',
            width: '80%',
            items: [{
                type: 'documentPanel',
                title: 'Component Configuration parameters',
                contentContainer: 'compConfigContainer'
            }]
        }]
    }];
    $('#compLayout').jqxLayout({ layout: layout });
}

function store_configuration(editor) {
    return function() {
        try {
            text = JSON.stringify(editor.get(), null, 0);
            data = JSON.stringify({
                    'component': selected_item.component,
                    'tag': selected_item.tag,
                    'config': JSON.parse(text)
            });

            $.post('/config/api/update_config/'+selected_item.component, data, function(result) {
                    display_ack_window("Configuration updated", "Configuration for service "+selected_item.component+" updated successfully");
            }).fail( function() {
                    display_ack_window("Configuration not updated", "Error configuring component "+selected_item.component);
            });
        }
        catch (e) {
            display_ack_window("Configuration not updated", "Error configuring component "+e);
        }
    }
}

function create_save_button(editor) {

    $("#saveConfig").attr("value", "Save Configuration");
    $("#saveConfig").jqxButton({ theme: 'darkblue' });
    document.getElementById('saveConfig').addEventListener('click', store_configuration(editor));

}
